package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.OrgaoCancelacionDAO;
import com.rjconsultores.ventaboletos.entidad.OrgaoCancelacion;
import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.service.OrgaoCancelacionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("orgaoCancelacionService")
public class OrgaoCancelacionServiceImpl implements OrgaoCancelacionService{

	@Autowired
	private OrgaoCancelacionDAO orgaoCancelacionDAO;

	public List<OrgaoCancelacion> obtenerTodos() {
		return orgaoCancelacionDAO.obtenerTodos();
	}

	public OrgaoCancelacion obtenerID(Integer id) {
		return orgaoCancelacionDAO.obtenerID(id);
	}

	@Transactional
	public OrgaoCancelacion suscribirActualizacion(OrgaoCancelacion entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);
		
		if (entidad.getOrgaoCancelacionId() != null){
			return orgaoCancelacionDAO.actualizacion(entidad);
		} else {
			return orgaoCancelacionDAO.suscribir(entidad);
		}
	}

	@Transactional
	public void borrar(OrgaoCancelacion entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		orgaoCancelacionDAO.actualizacion(entidad);
	}

	public List<OrgaoCancelacion> buscarPorOrgao(OrgaoConcedente orgaoConcedente) {
		return orgaoCancelacionDAO.buscarPorOrgao(orgaoConcedente);
	}
}
